## ufo-core 0.13.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

if (POLICY CMP0053)
cmake_policy(SET CMP0053 OLD)
endif ()

if (POLICY CMP0054)
cmake_policy(SET CMP0054 OLD)
endif ()

project(ufo C)

set(TARNAME "libufo")

set(UFO_NAME                "libufo")
set(UFO_DESCRIPTION         "UFO high-speed image processing core library")
set(UFO_DESCRIPTION_SUMMARY "UFO high-speed image processing core library")

#{{{ Library version
set(UFO_VERSION_MAJOR "0")
set(UFO_VERSION_MINOR "13")
set(UFO_VERSION_PATCH "0")
set(UFO_VERSION "${UFO_VERSION_MAJOR}.${UFO_VERSION_MINOR}.${UFO_VERSION_PATCH}")
set(UFO_GIR_VERSION "${UFO_VERSION_MAJOR}.0")
#}}}
#{{{ CMake
enable_testing()

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/common/cmake")

include(GNUInstallDirs)
include(PkgConfigVars)

set(CMAKE_INSTALL_INCLUDEDIR    "${CMAKE_INSTALL_INCLUDEDIR}/ufo-${UFO_VERSION_MAJOR}")
set(CMAKE_INSTALL_KERNELDIR     "${CMAKE_INSTALL_DATAROOTDIR}/ufo")
set(CMAKE_INSTALL_GIRDIR        "${CMAKE_INSTALL_DATAROOTDIR}/gir-1.0")
set(CMAKE_INSTALL_PLUGINDIR     "${CMAKE_INSTALL_LIBDIR}/ufo")
set(CMAKE_INSTALL_TYPELIBDIR    "${CMAKE_INSTALL_LIBDIR}/girepository-1.0")
set(CMAKE_INSTALL_PKGCONFIGDIR  "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

if (APPLE)
    set(CMAKE_MACOSX_RPATH      "ON")
    set(CMAKE_INSTALL_RPATH     "${CMAKE_INSTALL_PREFIX}/lib")
endif()

#}}}
#{{{ Options
option(WITH_TESTS "Build test suite" ON)
option(WITH_DEPRECATED_OPENCL_1_1_API "Build with deprecated OpenCL 1.1 API" ON)

if (WITH_DEPRECATED_OPENCL_1_1_API)
    add_definitions ("-DCL_USE_DEPRECATED_OPENCL_1_1_APIS")
endif ()
#}}}
#{{{ Dependencies
set(PKG_GLIB2_MIN_REQUIRED "2.30")
set(PKG_JSON_GLIB_MIN_REQUIRED "0.10.0")
set(PKG_ZMQ_MIN_REQUIRED "2.1")

find_package(OpenCL REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(MPI)

pkg_check_modules(GLIB2 glib-2.0>=${PKG_GLIB2_MIN_REQUIRED} REQUIRED)
pkg_check_modules(GOBJECT2 gobject-2.0>=${PKG_GLIB2_MIN_REQUIRED} REQUIRED)
pkg_check_modules(GMODULE2 gmodule-2.0>=${PKG_GLIB2_MIN_REQUIRED} REQUIRED)
pkg_check_modules(GTHREAD2 gthread-2.0>=${PKG_GLIB2_MIN_REQUIRED} REQUIRED)
pkg_check_modules(GIO2 gio-2.0>=${PKG_GLIB2_MIN_REQUIRED} REQUIRED)
pkg_check_modules(JSON_GLIB json-glib-1.0>=${PKG_JSON_GLIB_MIN_REQUIRED} REQUIRED)
pkg_check_modules(ZMQ libzmq>=${PKG_ZMQ_MIN_REQUIRED})
pkg_check_modules(PYTHON python)
pkg_check_modules(PYTHON27 python-2.7)

set(UFOCORE_DEPS
    m
    ${OpenCL_LIBRARIES}
    ${GLIB2_LIBRARIES}
    ${GOBJECT2_LIBRARIES}
    ${GMODULE2_LIBRARIES}
    ${GTHREAD2_LIBRARIES}
    ${GIO2_LIBRARIES}
    ${JSON_GLIB_LIBRARIES})

if (PYTHON_FOUND OR PYTHON27_FOUND)
    option(WITH_PYTHON "Enable Python multithreading support" ON)

    if (WITH_PYTHON)
        if (PYTHON_FOUND)
            include_directories(${PYTHON_INCLUDE_DIRS})
            list(APPEND UFOCORE_DEPS ${PYTHON_LIBRARIES})
        endif ()

        if (PYTHON27_FOUND)
            include_directories(${PYTHON27_INCLUDE_DIRS})
            list(APPEND UFOCORE_DEPS ${PYTHON27_LIBRARIES})
        endif ()
    endif ()
endif ()

if (MPI_C_FOUND)
    option(WITH_MPI "Build with MPI support" OFF)

    if (WITH_MPI)
        set(CMAKE_C_COMPILER ${MPI_C_COMPILER})
        include_directories(${MPI_C_INCLUDE_PATH})
        list(APPEND UFOCORE_DEPS ${MPI_C_LIBRARIES})
    endif ()
endif ()

if (ZMQ_FOUND)
    option(WITH_ZMQ "Build with ZMQ support" ON)

    if (WITH_ZMQ)
        link_directories(${ZMQ_LIBRARY_DIRS})
        include_directories(${ZMQ_INCLUDE_DIRS})
        list(APPEND UFOCORE_DEPS ${ZMQ_LIBRARIES})
    endif ()
endif ()

#{{{ Link dirs of dependencies
link_directories(
    ${GLIB2_LIBRARY_DIRS}
    ${JSON_GLIB_LIBRARY_DIRS})
#}}}
#{{{ Add include directories
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${GLIB2_INCLUDE_DIRS}
    ${GIO2_INCLUDE_DIRS}
    ${OpenCL_INCLUDE_DIRS}
    ${JSON_GLIB_INCLUDE_DIRS})
#}}}
#}}}
#{{{ Definitions
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -Wall -Wextra -fPIC -Wno-unused-parameter -Wno-deprecated-declarations")

add_definitions(-DG_LOG_DOMAIN=\"Ufo\"
                -D_FILE_OFFSET_BITS=64)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/config.h)
#}}}
#{{{ Subdirectories
add_subdirectory(ufo)
add_subdirectory(docs)
add_subdirectory(bin)

if (WITH_TESTS)
    add_subdirectory(tests)
endif()
#}}}

=== bin/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

#{{{ Binaries
add_executable(ufo-launch ufo-launch.c)
add_executable(ufo-query ufo-query.c)
add_executable(ufo-runjson ufo-runjson.c)
add_executable(ufod ufod.c)

target_link_libraries(ufo-launch ufo ${UFOCORE_DEPS})
target_link_libraries(ufo-query ufo ${UFOCORE_DEPS})
target_link_libraries(ufo-runjson ufo ${UFOCORE_DEPS})
target_link_libraries(ufod ufo ${UFOCORE_DEPS})

install(TARGETS ufod ufo-launch ufo-query ufo-runjson
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/ufo-prof
        DESTINATION ${CMAKE_INSTALL_BINDIR})

option(INSTALL_COMPLETION "Install Bash completion script" OFF)

if (INSTALL_COMPLETION)
    pkg_check_variable(bash-completion completionsdir)

    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/ufo-launch
            DESTINATION ${BASH_COMPLETION_COMPLETIONSDIR}
            OPTIONAL)
endif()
#}}}
#{{{ systemd .service file
pkg_check_modules(SYSTEMD systemd)

if (SYSTEMD_FOUND)
    pkg_check_variable(systemd systemdsystemunitdir)

    option(WITH_SYSTEMD "Install systemd unit file" OFF)

    if (WITH_SYSTEMD)
        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ufod.service.in
                       ${CMAKE_CURRENT_BINARY_DIR}/ufod.service
                       @ONLY IMMEDIATE)
       install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ufod.service
               DESTINATION ${SYSTEMD_SYSTEMDSYSTEMUNITDIR})
    endif ()
endif ()
#}}}
#{{{ ufo-mkfilter
set(CMAKE_INSTALL_TEMPLATEDIR "${CMAKE_INSTALL_FULL_DATADIR}/ufo/templates")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ufo-mkfilter.in
               ${CMAKE_CURRENT_BINARY_DIR}/ufo-mkfilter
               @ONLY IMMEDIATE)

file(GLOB templates "templates/*.in")

install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/ufo-mkfilter
        DESTINATION ${CMAKE_INSTALL_BINDIR})

install(FILES ${templates}
        DESTINATION ${CMAKE_INSTALL_TEMPLATEDIR})
#}}}

=== ufo/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

#{{{ sources
set(ufocore_SRCS
    compat.c
    ufo-priv.c
    ufo-base-scheduler.c
    ufo-copy-task.c
    ufo-buffer.c
    ufo-copyable-iface.c
    ufo-cpu-node.c
    ufo-daemon.c
    ufo-dummy-task.c
    ufo-fixed-scheduler.c
    ufo-gpu-node.c
    ufo-graph.c
    ufo-group.c
    ufo-group-scheduler.c
    ufo-input-task.c
    ufo-local-scheduler.c
    ufo-messenger-iface.c
    ufo-method-iface.c
    ufo-node.c
    ufo-output-task.c
    ufo-plugin-manager.c
    ufo-profiler.c
    ufo-processor.c
    ufo-remote-node.c
    ufo-remote-task.c
    ufo-resources.c
    ufo-scheduler.c
    ufo-task-iface.c
    ufo-task-graph.c
    ufo-task-node.c
    ufo-transform-iface.c
    ufo-two-way-queue.c
    ufo-basic-ops.c
    )
#}}}
#{{{ headers
set(ufocore_HDRS
    ufo-base-scheduler.h
    ufo-copy-task.h
    ufo-buffer.h
    ufo-copyable-iface.h
    ufo-cpu-node.h
    ufo-daemon.h
    ufo-dummy-task.h
    ufo-fixed-scheduler.h
    ufo-gpu-node.h
    ufo-graph.h
    ufo-group.h
    ufo-group-scheduler.h
    ufo-input-task.h
    ufo-local-scheduler.h
    ufo-messenger-iface.h
    ufo-method-iface.h
    ufo-node.h
    ufo-output-task.h
    ufo-plugin-manager.h
    ufo-profiler.h
    ufo-processor.h
    ufo-remote-node.h
    ufo-remote-task.h
    ufo-resources.h
    ufo-scheduler.h
    ufo-task-iface.h
    ufo-task-graph.h
    ufo-task-node.h
    ufo-transform-iface.h
    ufo-two-way-queue.h
    ufo-basic-ops.h
    )
#}}}
#{{{ libufo

add_definitions(-DUFO_COMPILATION)

if(CMAKE_BUILD_TYPE MATCHES "Release")
    add_definitions(-DG_DISABLE_ASSERT)
endif()

if (WITH_ZMQ)
    list(APPEND ufocore_SRCS ufo-zmq-messenger.c)
    list(APPEND ufocore_HDRS ufo-zmq-messenger.h)
endif ()

add_library(ufo SHARED ${ufocore_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/ufo-enums.c)

set_target_properties(ufo PROPERTIES
    VERSION ${UFO_VERSION}
    SOVERSION ${UFO_VERSION_MAJOR})

target_link_libraries(ufo ${UFOCORE_DEPS})

#{{{ install target
install(TARGETS ufo
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(FILES ${ufocore_HDRS}
              ${CMAKE_CURRENT_SOURCE_DIR}/ufo.h
              ${CMAKE_CURRENT_BINARY_DIR}/ufo-enums.h
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ufo)

install(FILES ufo-basic-ops.cl
        DESTINATION ${CMAKE_INSTALL_KERNELDIR})
#}}}
#}}}
#{{{ glib-mkenums
find_program(GLIB2_MKENUMS glib-mkenums REQUIRED)

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ufo-enums.h
    COMMAND ${GLIB2_MKENUMS}
    ARGS
        --template ufo-enums.h.template
        ${ufocore_HDRS} > ${CMAKE_CURRENT_BINARY_DIR}/ufo-enums.h
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ${ufocore_HDRS}
            ${CMAKE_CURRENT_SOURCE_DIR}/ufo-enums.h.template
)

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ufo-enums.c
    COMMAND ${GLIB2_MKENUMS}
    ARGS
        --template ufo-enums.c.template
        ${ufocore_HDRS} > ${CMAKE_CURRENT_BINARY_DIR}/ufo-enums.c
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ${ufocore_HDRS} ${CMAKE_CURRENT_BINARY_DIR}/ufo-enums.h
            ${CMAKE_CURRENT_SOURCE_DIR}/ufo-enums.c.template
)
#}}}
#{{{ GObject introspection
pkg_check_modules(GOBJECT_INTROSPECTION gobject-introspection-1.0)

if (GOBJECT_INTROSPECTION_FOUND)
    option(WITH_GIR "Build introspection files" ON)

    if (WITH_GIR)
        pkg_check_variable(gobject-introspection-1.0 g_ir_scanner)
        pkg_check_variable(gobject-introspection-1.0 g_ir_compiler)

        set(GIR_PREFIX "Ufo-${UFO_GIR_VERSION}")
        set(GIR_XML "${GIR_PREFIX}.gir")
        set(GIR_TYPELIB "${GIR_PREFIX}.typelib")
        set(_gir_input)

        foreach(_src ${ufocore_SRCS} ${ufocore_HDRS})
            list(APPEND _gir_input "${CMAKE_CURRENT_SOURCE_DIR}/${_src}")
        endforeach()

        add_custom_command(OUTPUT ${GIR_XML}
            COMMAND ${GOBJECT_INTROSPECTION_1.0_G_IR_SCANNER}
                    --namespace=Ufo
                    --nsversion=${UFO_GIR_VERSION}
                    --library=ufo
                    --no-libtool
                    --include=GObject-2.0
                    --include=GModule-2.0
                    --include=GLib-2.0
                    --include=Json-1.0
                    -I${OPENCL_INCLUDE_DIRS}
                    -I${JSON_GLIB_INCLUDE_DIRS}
                    -I${CMAKE_CURRENT_SOURCE_DIR}/..
                    -DUFO_COMPILATION
                    --output ${GIR_XML}
                    --warn-all
                    --quiet
                    ${_gir_input}
            DEPENDS ${ufocore_SRCS}
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

        add_custom_command(OUTPUT ${GIR_TYPELIB}
            COMMAND ${GOBJECT_INTROSPECTION_1.0_G_IR_COMPILER}
                    -o ${GIR_TYPELIB}
                    ${GIR_XML}
            DEPENDS ${GIR_XML}
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

        add_custom_target(gir ALL DEPENDS ${GIR_XML} ${GIR_TYPELIB})
        add_dependencies(gir ufo)

        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${GIR_XML}
                DESTINATION ${CMAKE_INSTALL_GIRDIR})

        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${GIR_TYPELIB}
                DESTINATION ${CMAKE_INSTALL_TYPELIBDIR})
    endif()
endif()
#}}}
#{{{ gtk-doc
pkg_check_modules(GTK_DOC gtk-doc)

if(GTK_DOC_FOUND)
    option(WITH_GTK_DOC "Build API reference" ON)
    if (WITH_GTK_DOC)
        find_program(GTK_DOC_SCAN gtkdoc-scan REQUIRED)
        find_program(GTK_DOC_SCANGOBJ gtkdoc-scangobj REQUIRED)
        find_program(GTK_DOC_MKDB gtkdoc-mkdb REQUIRED)
        find_program(GTK_DOC_MKHTML gtkdoc-mkhtml REQUIRED)

        set(docs_dir "${CMAKE_CURRENT_BINARY_DIR}/../docs")
        set(docs_out "${docs_dir}/reference")
        set(docs_xml_in "${CMAKE_CURRENT_SOURCE_DIR}/../docs/Ufo-docs.xml")
        set(docs_xml_out "${docs_out}/Ufo-docs.xml")
        set(docs_ignore_headers "ufo-zmq-messenger.h" "ufo-mpi-messenger.h")

        set(GTK_DOC_CFLAGS)
        set(GTK_DOC_LDFLAGS)

        get_directory_property(_current_include_dirs INCLUDE_DIRECTORIES)

        foreach(_incl ${_current_include_dirs})
            set(GTK_DOC_CFLAGS "-I${_incl} ${GTK_DOC_CFLAGS}")
        endforeach()

        foreach(_lib ${UFOCORE_DEPS})
            if (NOT ${_lib} MATCHES "^[/]")
                set(GTK_DOC_LDFLAGS "-l${_lib} ${GTK_DOC_LDFLAGS}")
            endif()
        endforeach()

        get_directory_property(_current_link_dirs LINK_DIRECTORIES)

        foreach(_linkdir ${_current_link_dirs})
            set(GTK_DOC_LDFLAGS "-L${_linkdir} ${GTK_DOC_LDFLAGS}")
        endforeach()

        configure_file("${CMAKE_CURRENT_SOURCE_DIR}/../docs/scangobj.sh.in" "${docs_out}/scangobj.sh")

        add_custom_target(docbook)
        add_custom_command(TARGET docbook PRE_BUILD
                           COMMAND ${CMAKE_COMMAND} -E
                                   copy ${docs_xml_in} ${docs_xml_out}
                                   DEPENDS ${docs_xml_out})

        add_custom_command(OUTPUT ${docs_out}/Ufo-decl.txt
            COMMAND ${GTK_DOC_SCAN}
                    --module=Ufo
                    --source-dir=${CMAKE_CURRENT_SOURCE_DIR}
                    --ignore-headers="${docs_ignore_headers}"
            DEPENDS ufo
            COMMENT "Running gtkdoc-scan"
            WORKING_DIRECTORY ${docs_out})

        add_custom_command(OUTPUT ${docs_out}/Ufo.args
            COMMAND sh scangobj.sh
            DEPENDS ufo ${docs_out}/Ufo-decl.txt
            COMMENT "Running gtkdoc-scangobj"
            WORKING_DIRECTORY ${docs_out})

        add_custom_command(OUTPUT ${docs_out}/sgml.stamp
            COMMAND ${GTK_DOC_MKDB}
                    --module=Ufo
                    --source-dir=${CMAKE_CURRENT_SOURCE_DIR}
                    --sgml-mode
                    --output-format=xml
            DEPENDS ufo ${docs_out}/Ufo.args
            COMMENT "Running gtkdoc-mkdb"
            WORKING_DIRECTORY ${docs_out})

        add_custom_command(OUTPUT ${docs_dir}/html.stamp
            COMMAND ${GTK_DOC_MKHTML}
                    --path="${CMAKE_CURRENT_BINARY_DIR}/../docs/reference"
                    Ufo
                    ${docs_xml_out}
            DEPENDS ufo ${docs_out}/sgml.stamp docbook
            COMMENT "Running gtkdoc-mkhtml"
            WORKING_DIRECTORY ${docs_out})

        add_custom_target(reference ALL DEPENDS ${docs_dir}/html.stamp)

        install(DIRECTORY ${docs_out}/
                DESTINATION ${CMAKE_INSTALL_DATADIR}/gtk-doc/html/Ufo
                FILES_MATCHING REGEX ".*\\.(html|png|devhelp2|css)$"
                PATTERN "xml" EXCLUDE)
    endif()
endif(GTK_DOC_FOUND)
#}}}
#{{{ pkg-config
# FIXME: inside the ufo.pc.in we should set the lib names that we found out, not
# hard coded values
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/ufo.pc.in"
               "${CMAKE_CURRENT_BINARY_DIR}/ufo.pc" @ONLY IMMEDIATE)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ufo.pc
        DESTINATION ${CMAKE_INSTALL_PKGCONFIGDIR})
#}}}

=== debian/changelog ===
ufo-core (0.13.0-1) unstable; urgency=medium

  * New upstream release.

 -- Picca Frédéric-Emmanuel <picca@synchrotron-soleil.fr>  Wed, 25 Jan 2017 18:15:20 +0100

ufo-core (0.12.1-1) unstable; urgency=medium

  * New upstream release.

 -- Picca Frédéric-Emmanuel <picca@synchrotron-soleil.fr>  Sun, 04 Dec 2016 10:37:58 +0100

ufo-core (0.12.0-1) unstable; urgency=medium

  * New upstream release.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sat, 26 Nov 2016 09:33:53 +0100

ufo-core (0.11.1-1) unstable; urgency=low

  * Initial release (Closes: #843970)

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 11 Nov 2013 09:07:17 +0100

=== debian/control ===
Source: ufo-core
Maintainer: Picca Frédéric-Emmanuel <picca@debian.org>
Section: libs
Priority: extra
Build-Depends: debhelper (>= 10),
               asciidoc,
               bash-completion,
               cmake,
               dh-python,
               dh-systemd (>= 1.5),
               gobject-introspection,
               gtk-doc-tools,
               libglib2.0-dev,
               libgirepository1.0-dev,
               libjson-glib-dev,
               libzmq3-dev,
               ocl-icd-opencl-dev,
               python-dev,
               python-sphinx,
               systemd,
Standards-Version: 3.9.8
Vcs-Browser: http://anonscm.debian.org/cgit/debian-pan/packages/ufo-core.git
Vcs-Git: https://anonscm.debian.org/git/debian-pan/packages/ufo-core.git
Homepage: http://ufo.kit.edu/

Package: gir1.2-ufo-0.0
Architecture: any
Multi-Arch: same
Section: introspection
Depends: ${gir:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Library for high-performance, GPU-based computing - gir binding
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 A gobject-instrospection binding is also provided to write scripts or
 user interfaces.
 .
 This package can be used by other packages using the GIRepository
 format to generate dynamic bindings.

Package: libufo0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libufo-data (= ${source:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: Library for high-performance, GPU-based computing - runtime
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 A gobject-instrospection binding is also provided to write scripts or
 user interfaces.
 .
 This package provides the runtime for libufo.

Package: libufo-bin
Architecture: any
Depends: ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
Description: Library for high-performance, GPU-based computing - tools
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 A gobject-instrospection binding is also provided to write scripts or
 user interfaces.
 .
 This package contains binaries to run JSON descriptions of task graphs.

Package: libufo-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Library for high-performance, GPU-based computing - data
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 A gobject-instrospection binding is also provided to write scripts or
 user interfaces.
 .
 This package provides the openCL kernel files and templates to write
 ufo filters

Package: libufo-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         gir1.2-ufo-0.0 (= ${binary:Version}),
         libglib2.0-dev,
         libjson-glib-dev,
         libufo0 (= ${binary:Version}),
         libzmq3-dev,
         ocl-icd-opencl-dev,
         libpython-dev
Pre-Depends: ${misc:Pre-Depends}
Description: Library for high-performance, GPU-based computing - devel
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 A gobject-instrospection binding is also provided to write scripts or
 user interfaces.
 .
 This package contain the development files for libufo.

Package: ufod
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Library for high-performance, GPU-based computing - daemon
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 A gobject-instrospection binding is also provided to write scripts or
 user interfaces.
 .
 This package contains the ufod daemon that serves computation requests
 from a remote master node.

Package: ufo-core-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Description: Library for high-performance, GPU-based computing - documentation
 The UFO data processing framework is a C library suited to build
 general purpose streams data processing on heterogeneous
 architectures such as CPUs, GPUs or clusters. It is extensively used
 at the Karlsruhe Institute of Technology for Ultra-fast X-ray Imaging
 (radiography, tomography and laminography).
 .
 A gobject-instrospection binding is also provided to write scripts or
 user interfaces.
 .
 This package provides the documentation for libufo.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

%:
	dh $@ --with gir,python2,sphinxdoc,systemd --without autoreconf --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DINSTALL_COMPLETION=ON -DWITH_SYSTEMD=ON

override_dh_install:
	# gir1.2-ufo-0.0
	dh_install -p gir1.2-ufo-0.0 usr/lib/*/girepository-1.0

	# libufo-bin
	dh_install -p libufo-bin usr/bin/ufo-*
	dh_install -p libufo-bin usr/share/man/man1/ufo-*
	dh_install -p libufo-bin usr/share/bash-completion

	# libufo-data
	dh_install -p libufo-data usr/share/ufo

	# libufo-dev
	dh_install -p libufo-dev usr/include/*
	dh_install -p libufo-dev usr/lib/*/lib*.so
	dh_install -p libufo-dev usr/lib/*/pkgconfig
	dh_install -p libufo-dev usr/share/gir-1.0/

	# libufo0
	dh_install -p libufo0 usr/lib/*/lib*.so.*

	# ufod
	dh_install -p ufod lib/systemd/system
	dh_install -p ufod usr/bin/ufod
	dh_install -p ufod usr/share/man/man1/ufod.1

	# ufo-core-doc
	dh_install -p ufo-core-doc usr/share/gtk-doc
	dh_install -p ufo-core-doc ./*/docs/manual/html usr/share/doc/ufo-core-doc

	dh_install --remaining-packages --list-missing

## ufo-core 0.15.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,8 +18,8 @@
 
 #{{{ Library version
 set(UFO_VERSION_MAJOR "0")
-set(UFO_VERSION_MINOR "13")
-set(UFO_VERSION_PATCH "0")
+set(UFO_VERSION_MINOR "15")
+set(UFO_VERSION_PATCH "1")
 set(UFO_VERSION "${UFO_VERSION_MAJOR}.${UFO_VERSION_MINOR}.${UFO_VERSION_PATCH}")
 set(UFO_GIR_VERSION "${UFO_VERSION_MAJOR}.0")
 #}}}
@@ -69,7 +69,6 @@
 pkg_check_modules(JSON_GLIB json-glib-1.0>=${PKG_JSON_GLIB_MIN_REQUIRED} REQUIRED)
 pkg_check_modules(ZMQ libzmq>=${PKG_ZMQ_MIN_REQUIRED})
 pkg_check_modules(PYTHON python)
-pkg_check_modules(PYTHON27 python-2.7)
 
 set(UFOCORE_DEPS
     m
@@ -81,21 +80,14 @@
     ${GIO2_LIBRARIES}
     ${JSON_GLIB_LIBRARIES})
 
-if (PYTHON_FOUND OR PYTHON27_FOUND)
+if (PYTHON_FOUND)
     option(WITH_PYTHON "Enable Python multithreading support" ON)
 
     if (WITH_PYTHON)
-        if (PYTHON_FOUND)
-            include_directories(${PYTHON_INCLUDE_DIRS})
-            list(APPEND UFOCORE_DEPS ${PYTHON_LIBRARIES})
-        endif ()
-
-        if (PYTHON27_FOUND)
-            include_directories(${PYTHON27_INCLUDE_DIRS})
-            list(APPEND UFOCORE_DEPS ${PYTHON27_LIBRARIES})
-        endif ()
+        include_directories(${PYTHON_INCLUDE_DIRS})
+        list(APPEND UFOCORE_DEPS ${PYTHON_LIBRARIES})
     endif ()
-endif ()
+endif()
 
 if (MPI_C_FOUND)
     option(WITH_MPI "Build with MPI support" OFF)
@@ -133,7 +125,7 @@
 #}}}
 #}}}
 #{{{ Definitions
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -Wall -Wextra -fPIC -Wno-unused-parameter -Wno-deprecated-declarations")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -Wextra -fPIC -Wno-unused-parameter -Wno-deprecated-declarations")
 
 add_definitions(-DG_LOG_DOMAIN=\"Ufo\"
                 -D_FILE_OFFSET_BITS=64)

=== meson_options.txt ===
option('gtk_doc',
    type: 'boolean', value: false,
    description: 'Build API references (requires gtk-doc)')

option('introspection',
    type: 'boolean', value: true,
    description: 'Build introspection data (requires gobject-introspection')

=== bin/CMakeLists.txt ===
--- 
+++ 
@@ -6,10 +6,10 @@
 add_executable(ufo-runjson ufo-runjson.c)
 add_executable(ufod ufod.c)
 
-target_link_libraries(ufo-launch ufo ${UFOCORE_DEPS})
-target_link_libraries(ufo-query ufo ${UFOCORE_DEPS})
-target_link_libraries(ufo-runjson ufo ${UFOCORE_DEPS})
-target_link_libraries(ufod ufo ${UFOCORE_DEPS})
+target_link_libraries(ufo-launch ufo)
+target_link_libraries(ufo-query ufo)
+target_link_libraries(ufo-runjson ufo)
+target_link_libraries(ufod ufo)
 
 install(TARGETS ufod ufo-launch ufo-query ufo-runjson
         RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== docs/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

find_program(SPHINX sphinx-build PATHS /usr/local/bin /usr/bin)
find_program(A2X NAMES a2x a2x.py)
mark_as_advanced(SPHINX)
mark_as_advanced(A2X)

# --- End-user manual ---------------------------------------------------------
if(SPHINX)
    option(WITH_MANUAL "Build user manual" ON)

    if (WITH_MANUAL)
        set(input_dir ${CMAKE_CURRENT_SOURCE_DIR}/manual)
        set(output_dir ${CMAKE_CURRENT_BINARY_DIR}/manual/html)

        file(GLOB_RECURSE sphinx_source ${input_dir}/*.rst)
        
        foreach(file ${sphinx_static})
            configure_file(${input_dir}/${file} ${output_dir}/${file} COPYONLY)
        endforeach()

        add_custom_command(OUTPUT ${output_dir}/index.html
            COMMAND ${SPHINX} -b html ${input_dir} ${output_dir}
            DEPENDS ${sphinx_source}
            COMMENT "Build Sphinx HTML")

        add_custom_target(manual ALL DEPENDS ${output_dir}/index.html)

        add_dependencies(manual ufo)
    endif()
endif()

# --- Manpages # --------------------------------------------------------------
if (A2X)
    option(WITH_MANPAGES "Build manpages" ON)

    if (WITH_MANPAGES)
        set(MAN_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/man)
        set(MAN_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR}/man/man1)

        file(MAKE_DIRECTORY ${MAN_BUILD_DIR})

        set(A2X_OPTS
            -L
            -D ${MAN_BUILD_DIR}
            -d manpage
            -f manpage
            )

        set(MAN_NAMES
            ufo-launch.1
            ufo-mkfilter.1
            ufo-query.1
            ufo-prof.1
            ufo-runjson.1
            ufod.1
            )

        set(MAN_FILES)

        foreach(m IN LISTS MAN_NAMES)
            set(mf ${MAN_BUILD_DIR}/${m})
            set(ms ${MAN_SOURCE_DIR}/${m}.txt)

            add_custom_command(OUTPUT ${mf}
                COMMAND ${A2X} ${A2X_OPTS} ${ms}
                DEPENDS ${ms}
                COMMENT "Building manpage ${m}"
                VERBATIM)

            list(APPEND MAN_FILES ${mf})
            install(FILES ${mf} DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
        endforeach()

        add_custom_target(man ALL DEPENDS ${MAN_FILES})
    endif ()
endif ()

=== python/Makefile ===
install:
	@python setup.py install

check:
	@nosetests tests/

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(TEST_SRCS
    test-suite.c
    test-buffer.c
    test-graph.c
    test-node.c
    test-profiler.c
    )

set(SUITE_BIN "test-suite")

if (WITH_ZMQ)
    list(APPEND TEST_SRCS test-zmq-messenger.c)
endif ()

add_executable(${SUITE_BIN} ${TEST_SRCS})

target_link_libraries(${SUITE_BIN} ufo m ${UFOCORE_DEPS})

add_test(${SUITE_BIN} ${SUITE_BIN})

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/gtester.xsl"
               "${CMAKE_CURRENT_BINARY_DIR}/gtester.xsl"
               @ONLY IMMEDIATE)

=== ufo/CMakeLists.txt ===
--- 
+++ 
@@ -85,6 +85,8 @@
     list(APPEND ufocore_HDRS ufo-zmq-messenger.h)
 endif ()
 
+include_directories(${CMAKE_CURRENT_SOURCE_DIR})
+
 add_library(ufo SHARED ${ufocore_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/ufo-enums.c)
 
 set_target_properties(ufo PROPERTIES

=== docs/manual/requirements.txt ===
https://github.com/djungelorm/sphinx-tabs/releases/download/v1.1.5/sphinx-tabs-1.1.5.post11.tar.gz

=== debian/changelog ===
ufo-core (0.15.1-3build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 05:44:41 +0000

ufo-core (0.15.1-3) unstable; urgency=medium

  * d/p/0002-switch-bin-scripts-to-Python3.patch: Added (Closes: #938743)

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 19 Jan 2020 09:42:29 +0100

ufo-core (0.15.1-2) unstable; urgency=medium

  [ Alexandre Marie ]
  * Refreshed debian/changelog
  * Remove py2 in debian/control and debian/rules
  * Added myself to uploaders
  * Changed standard version in debian/control
  * Closes: #938743

  [ Frédéric Picca ]
  * Use debhelper-compat instead of debian/compat.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 08 Dec 2019 20:40:25 +0100

ufo-core (0.15.1-1) unstable; urgency=medium

  * New upstream release.
  * d/control
    - Build-Depends : added python3-sphinx-rtd-theme
  * d/patches
    - 0001-Desactivate-sphinx_tabs-extension.patch (added)

 -- Serge Cohen <serge1cohen@free.fr>  Mon, 29 Jan 2018 14:15:35 +0100

ufo-core (0.14.0-2) unstable; urgency=medium

  * d/rules
    - use as-needed in order to reduce binary dependencies

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 08 Oct 2017 12:07:18 +0200

ufo-core (0.14.0-1) unstable; urgency=medium

  * New upstream release.
  * d/control
    - Added Suggests: ufo-core-doc (Closes: #847623)
    - Bump Standard-Version 4.1.1 (extra -> optional)
    - Removed obsolete Build-Depends: dh-systemd
    - Switched from python-sphinx to python3-sphinx

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 08 Oct 2017 09:47:30 +0200

=== debian/control ===
--- 
+++ 
@@ -1,35 +1,36 @@
 Source: ufo-core
-Maintainer: Picca Frédéric-Emmanuel <picca@debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Picca Frédéric-Emmanuel <picca@debian.org>,
+ Serge Cohen <serge1cohen@free.fr>,
+ Alexandre Marie <alexandre.marie@synchrotron-soleil.fr>
 Section: libs
-Priority: extra
-Build-Depends: debhelper (>= 10),
-               asciidoc,
+Priority: optional
+Build-Depends: asciidoc,
                bash-completion,
                cmake,
+               debhelper-compat (= 10),
                dh-python,
-               dh-systemd (>= 1.5),
                gobject-introspection,
                gtk-doc-tools,
+               libgirepository1.0-dev,
                libglib2.0-dev,
-               libgirepository1.0-dev,
                libjson-glib-dev,
                libzmq3-dev,
                ocl-icd-opencl-dev,
-               python-dev,
-               python-sphinx,
-               systemd,
-Standards-Version: 3.9.8
-Vcs-Browser: http://anonscm.debian.org/cgit/debian-pan/packages/ufo-core.git
-Vcs-Git: https://anonscm.debian.org/git/debian-pan/packages/ufo-core.git
+               python3-dev,
+               python3-sphinx,
+               python3-sphinx-rtd-theme,
+               systemd
+Standards-Version: 4.4.1
+Vcs-Browser: https://salsa.debian.org/science-team/ufo-core
+Vcs-Git: https://salsa.debian.org/science-team/ufo-core.git
 Homepage: http://ufo.kit.edu/
 
 Package: gir1.2-ufo-0.0
 Architecture: any
 Multi-Arch: same
 Section: introspection
-Depends: ${gir:Depends},
-         ${misc:Depends},
-         ${shlibs:Depends}
+Depends: ${gir:Depends}, ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Description: Library for high-performance, GPU-based computing - gir binding
  The UFO data processing framework is a C library suited to build
@@ -48,9 +49,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libs
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-         libufo-data (= ${source:Version})
+Depends: libufo-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Description: Library for high-performance, GPU-based computing - runtime
  The UFO data processing framework is a C library suited to build
@@ -66,9 +65,8 @@
 
 Package: libufo-bin
 Architecture: any
-Depends: ${misc:Depends},
-         ${python:Depends},
-         ${shlibs:Depends},
+Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
+Suggests: ufo-core-doc
 Description: Library for high-performance, GPU-based computing - tools
  The UFO data processing framework is a C library suited to build
  general purpose streams data processing on heterogeneous
@@ -102,15 +100,16 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: ${misc:Depends},
-         gir1.2-ufo-0.0 (= ${binary:Version}),
+Depends: gir1.2-ufo-0.0 (= ${binary:Version}),
          libglib2.0-dev,
          libjson-glib-dev,
+         libpython3-dev,
          libufo0 (= ${binary:Version}),
          libzmq3-dev,
          ocl-icd-opencl-dev,
-         libpython-dev
+         ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
+Suggests: ufo-core-doc
 Description: Library for high-performance, GPU-based computing - devel
  The UFO data processing framework is a C library suited to build
  general purpose streams data processing on heterogeneous
@@ -125,8 +124,8 @@
 
 Package: ufod
 Architecture: any
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Suggests: ufo-core-doc
 Description: Library for high-performance, GPU-based computing - daemon
  The UFO data processing framework is a C library suited to build
  general purpose streams data processing on heterogeneous
@@ -144,8 +143,7 @@
 Architecture: all
 Multi-Arch: foreign
 Section: doc
-Depends: ${misc:Depends},
-         ${sphinxdoc:Depends}
+Depends: ${misc:Depends}, ${sphinxdoc:Depends}
 Description: Library for high-performance, GPU-based computing - documentation
  The UFO data processing framework is a C library suited to build
  general purpose streams data processing on heterogeneous

=== debian/rules ===
--- 
+++ 
@@ -2,9 +2,11 @@
 # -*- makefile -*-
 
 #export DH_VERBOSE=1
+export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 %:
-	dh $@ --with gir,python2,sphinxdoc,systemd --without autoreconf --buildsystem=cmake
+	dh $@ --with gir,python3,sphinxdoc,systemd --without autoreconf --buildsystem=cmake
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DINSTALL_COMPLETION=ON -DWITH_SYSTEMD=ON
@@ -40,4 +42,3 @@
 	dh_install -p ufo-core-doc ./*/docs/manual/html usr/share/doc/ufo-core-doc
 
 	dh_install --remaining-packages --list-missing
-

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ufo-core-$1.tar.gz%" \
    https://github.com/ufo-kit/ufo-core/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
